/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

#ifndef __GFS_EA_DOT_H__
#define __GFS_EA_DOT_H__

/* the seteattr function's cmd argument must be one of these choices */
#define GFS_EA_SET       (0)
#define GFS_EA_CREATE    (1)
#define GFS_EA_REPLACE   (2)

#define GFS_EA_NAME_MAX (255)
#define GFS_EA_DATA_MAX (65535)

int gfs_seteattr(int fd, char *name, void *data, unsigned int size, int cmd);
int gfs_geteattr(int fd, char *name, void *data, unsigned int *sizep);
int gfs_geteattrsize(int fd, char *name, unsigned int *sizep);
int gfs_listeattr(int fd, char *list, unsigned int *sizep);
int gfs_listeattrsize(int fd, unsigned int *sizep);
int gfs_removeeattr(int fd, char *name);
char *gfs_eaerror(int err);

#endif /* __GFS_EA_DOT_H__ */
