/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  1997-2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**  
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/
#ifndef __FENCE_LOG_H__
#define __FENCE_LOG_H__
/* include all header files necessary for fence_log.c to compile */
#include <stdarg.h>
#include <syslog.h>
#include <stdio.h>

void fence_syslog_enable(void);
void log_sysprint(int priority, char *fmt, ...);
void log_print(int priority, char *fnt, ...);

#define log_dbg(LD_fmt, LD_args...) \
do \
{ \
  log_sysprint(LOG_DEBUG, LD_fmt, ##LD_args); \
  log_print(LOG_DEBUG, LD_fmt, ##LD_args); \
} \
while(0)

#define log_msg(LM_fmt, LM_args...) \
do \
{ \
  log_sysprint(LOG_NOTICE, LM_fmt, ##LM_args); \
  log_print(LOG_NOTICE, LM_fmt, ##LM_args); \
} \
while(0)

#define log_err(LE_fmt, LE_args...) \
do \
{ \
  log_sysprint(LOG_ERR, LE_fmt, ##LE_args); \
  log_print(LOG_ERR, LE_fmt, ##LE_args); \
} \
while(0)

#endif /* __FENCE_LOG_H__ */
