/******************************************************************************
*******************************************************************************
**
**  Copyright (C) Sistina Software, Inc.  2003  All rights reserved.
**  Copyright (C) 2004 Red Hat, Inc.  All rights reserved.
**
**  This copyrighted material is made available to anyone wishing to use,
**  modify, copy, or redistribute it subject to the terms and conditions
**  of the GNU General Public License v.2.
**
*******************************************************************************
******************************************************************************/

#ifndef __device_h__
#define __device_h__

#include <linux/file.h>
#include <linux/blkdev.h>

struct dev_info_s {
	char *name;
	char *path;
	kdev_t rdev;
	struct file *file;
	u64 size;
	int blksize;
	u32 timeout;
	u8 readonly;
	struct semaphore lock;	/* if you are also locking the list, lock the list first */
	list_t list;
};
typedef struct dev_info_s dev_info_t;

int create_device(char *name, char *path, u32 timeout, u8 readonly);
int remove_device(char *name, int force);
int full_list(char **buffer, u32 * list_size);
int names_list(char **buffer, u32 * list_size);
dev_info_t *find_and_lock_device(char *name);
void init_gserv_device(void);

#define cached(x) ((x)->timeout == 0)
#define needs_gulm(x) ((x)->timeout && !((x)->readonly))

#endif				/* __device_h__ */
